
class Dump(Exception):
	'''
	Emit a signal to dump environment
	'''
	module = None

	def __init__(self,module=None):
		self.module = module

	def __str__(self):
		if self.module:
			return "debug dump for `%s`" % (self.module.fn)
		else:
			return "debug dump"

class CommitRaise(Exception):
	pass

class CallPass(CommitRaise):
	'''
	Emit a signal to pass this commit call
	'''
	pass

class CallQueue(CommitRaise):
	'''
	Emit a signal to queue this commit call
	'''
	pass

class BranchPass(CommitRaise):
	'''
	Emit a signal to mark this branch as executed and pass commit
	'''
	pass